// SAME AS binarySearchTree, without the "NIL" node

import  java.io.*;
import  java.util.Scanner;
import  java.util.*;

class treeNode {
    int k; 
    treeNode l,r,p;
}

public class binarySearchTree1 {
    private static treeNode root, z;

//%%%%%%%%%%%%%%% AUXILIARY FUNCTIONS %%%%%%%%%%%%%%% 
 
  public static int readInfo () {
    Scanner in = new Scanner(System.in);    
    System.out.print("Insert value: ");
    int info = in.nextInt();
    return info;
  }


   public static void printArray(int a[]) {
	int i;
	for(i = 0; i < a.length; i++)
	    System.out.print(a[i] + " ");
	System.out.println();
    }

//%%%%%%%%%%%%%%% METHODS %%%%%%%%%%%%%%% 
    public static void init() {
	root =  null; 
    }

    private static void nodeprint(treeNode t) {
	if(t != null) {
	    nodeprint(t.l);
	    System.out.printf("%d ",t.k);
	    nodeprint(t.r);
	}
    }

     public static void print() {
	nodeprint(root); System.out.println();
    }

   
    private static int depth =0; // useful only for indented printing
    private static void nodeprintIndent(treeNode t) {
	depth++;
	if(t != null) {
	    nodeprintIndent(t.r);
            for (int i=1;i<=depth;i++) 
              System.out.printf("  ");
	    System.out.printf("%2d\n",t.k);
	    nodeprintIndent(t.l);
	}
	//	else System.out.print("null ");
        depth--;
    }

    public static void printIndent() {
	nodeprintIndent(root); System.out.println();
    }

    private static treeNode nodesearch(treeNode t, int v) {
	if(t == null || v == t.k) 
          return t;
	if(v < t.k) 
          return nodesearch(t.l, v);
	else 
          return nodesearch(t.r, v);
    }

    private static treeNode treesearch(int v) {
	return nodesearch(root, v);
    }

    public static int search(int v) {
	return treesearch(v).k;
    }

    private static treeNode nodemin(treeNode t) {
	while(t.l != null) 
          t = t.l;
	return t;
    }

    private static treeNode treemin() {
	return nodemin(root);
    }

    public static int min() {
	return treemin().k;
    }

    private static treeNode nodemax(treeNode t) {
	while(t.r != null) 
          t = t.r;
	return t;
    }

    private static treeNode treemax() {
	return nodemax(root);
    }

    public static int max() {
	return treemax().k;
    }

    private static treeNode treesucc(int v) {
	treeNode t, s;
	t = treesearch(v);
	if(t.r != null) 
          return nodemin(t.r);
	s = t.p;
	while(s != null && t == s.r) {
	    t = s; s = t.p;
	}
	return s ;
    }

    public static int succ(int v) {
	return treesucc(v).k;
    }

    private static treeNode treepred(int v) {
	treeNode t, s;
	t = treesearch(v);
	if(t.l != null) 
          return nodemax(t.l);
	s = t.p;
	while(s != null && t == s.l) {
	    t = s; s = t.p;
	}
	return s ;
    }

    public static int pred(int v) {
	return treepred(v).k;
    }

    public static void insert(int v) {
	treeNode t, prec;
	prec = null; 
        t = root;
	while(t != null) {
	    prec = t; 
            t = ((v < t.k) ? t.l : t.r);
	}
	t = new treeNode();
	t.k = v; t.p = prec; t.l = t.r = null;
	if(prec == null) { 
           root = t;
           t.p=null;
	}
	else if(v < prec.k) 
           prec.l = t; 
        else 
           prec.r = t;
    }

 // Deletes an element. 
 // If the element has two children, swap with its successor and drop it
 // (Like in Cormen et al.)
    public static void r_delete(int v) {
	treeNode t, s, r;
	t = treesearch(v);
        if (t==null)
	    return;
	if (t.l == null || t.r == null) // v has 0 or 1 children
          s = t; 
        else // v has 2 childred
          s = treesucc(v);
        // now s has at most one child
	if(s.l != null) 
          r = s.l; 
        else 
          r = s.r;
        if (r!=null)
	   r.p = s.p; 
	if(s.p == null) // s is the root
          root = r;
	else if(s == s.p.l) // s is a left child
          s.p.l = r; 
        else // s is a right child
          s.p.r = r;
	if(s != t) // v had 2 children
          t.k = s.k;
    }

 // Deletes an element. 
 // If the element has two children, swap with its predecessor and drop it
 // (Simmetric wrt.  in Cormen et al.)
    public static void l_delete(int v) {
	treeNode t, s, r;
	t = treesearch(v);
        if (t==null)
	    return;
	if (t.l == null || t.r == null) // v has 0 or 1 children
          s = t; 
        else // v has 2 childred
          s = treepred(v);
        // now s has at most one child
	if(s.l != null) 
          r = s.l; 
        else 
          r = s.r;
        if (r!=null)
	   r.p = s.p; 
	if(s.p == null) // s is the root
          root = r;
	else if(s == s.p.l) // s is a left child
          s.p.l = r; 
        else // s is a right child
          s.p.r = r;
	if(s != t) // v had 2 children
          t.k = s.k;
    }

  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      int key = 0;
      char option = 'a';
      String opt = null;
      treeNode  pos;
      init();
      do {
	    System.out.println("Options:");
	    System.out.println(" i: insert new element");
	    System.out.println(" r: delete the element with given key (right)");
	    System.out.println(" l: delete the element with given key (left)");
	    System.out.println(" s: search for an element");
	    System.out.println(" m: search for the minimum");
	    System.out.println(" M: search for the maximum");
	    System.out.println(" n: search for the successor");
	    System.out.println(" e: search for the predecessor");
	    System.out.println(" p: print ordered");
	    System.out.println(" d: print indented");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'i': 
              key = readInfo();
              insert(key);
		break;
	    case 'r': 
              key = readInfo();
              r_delete(key);
	      break;
	    case 'l': 
              key = readInfo();
              l_delete(key);
	      break;
	    case 's': 
              key = readInfo();
              pos= treesearch(key);
              if (pos==null)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'n': 
              key = readInfo();
              pos= treesucc(key);
              if (pos==null)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'e': 
              key = readInfo();
              pos= treepred(key);
              if (pos==null)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'm': 
              pos= treemin();
              if (pos==null)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'M': 
              pos= treemax();
              if (pos==null)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'p': 
              print();
	      break;
	    case 'd': 
              printIndent();
	      break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 'r' || 
         option == 'l' || 
         option == 's' || 
         option == 'm' || 
         option == 'M' || 
         option == 'n' || 
         option == 'd' || 
         option == 'p' 
        );
  }

}
