// different from slides
// here delete exploits the presence of parent field
// variant of a version by Kurt Ranalter

import  java.io.*;
import  java.util.Scanner;
import  java.util.*;

class treeNode {
    int k; 
    treeNode l,r,p;
}

public class binarySearchTree {
    private static treeNode root, nil;

//%%%%%%%%%%%%%%% AUXILIARY FUNCTIONS %%%%%%%%%%%%%%% 
 
  public static int readInfo () {
    Scanner in = new Scanner(System.in);    
    System.out.print("Insert value: ");
    int info = in.nextInt();
    return info;
  }

   public static int[] readArray() {
    Scanner in = new Scanner(System.in);    
    System.out.print("Length of the array: ");
    int size = in.nextInt();
    int[] a = new int[size];
    for (int i = 0; i < size; i++) {
       System.out.print("Insert the "+(i+1)+"-th value: ");
       a[i] = in.nextInt();
    }
    return a;   
   } 

   public static void printArray(int a[]) {
	int i;
	for(i = 0; i < a.length; i++)
	    System.out.print(a[i] + " ");
	System.out.println();
    }

//%%%%%%%%%%%%%%% METHODS %%%%%%%%%%%%%%% 
    public static void init() {
	nil = new treeNode();
	root = nil.p = nil.l = nil.r = nil; nil.k = 0;
    }

    private static void nodeprint(treeNode t) {
	if(t != nil) {
	    nodeprint(t.l);
	    System.out.printf("%d ",t.k);
	    nodeprint(t.r);
	}
    }

     public static void print() {
	nodeprint(root); System.out.println();
    }

   
    private static int depth =0; // useful only for indented printing
    private static void nodeprintIndent(treeNode t) {
	depth++;
	if(t != nil) {
	    nodeprintIndent(t.r);
            for (int i=1;i<=depth;i++) 
              System.out.printf("  ");
	    System.out.printf("%2d\n",t.k);
	    nodeprintIndent(t.l);
	}
	//	else System.out.print("nil ");
        depth--;
    }

    public static void printIndent() {
	nodeprintIndent(root); System.out.println();
    }

    private static treeNode nodesearch(treeNode t, int v) {
	if(t == nil || v == t.k) 
          return t;
	if(v < t.k) 
          return nodesearch(t.l, v);
	else 
          return nodesearch(t.r, v);
    }

    private static treeNode treesearch(int v) {
	return nodesearch(root, v);
    }

    public static int search(int v) {
	return treesearch(v).k;
    }

    private static treeNode nodemin(treeNode t) {
	while(t.l != nil) 
          t = t.l;
	return t;
    }

    private static treeNode treemin() {
	return nodemin(root);
    }

    public static int min() {
	return treemin().k;
    }

    private static treeNode nodemax(treeNode t) {
	while(t.r != nil) 
          t = t.r;
	return t;
    }

    private static treeNode treemax() {
	return nodemax(root);
    }

    public static int max() {
	return treemax().k;
    }

    private static treeNode treesucc(int v) {
	treeNode t, s;
	t = treesearch(v);
	if(t.r != nil) 
          return nodemin(t.r);
	s = t.p;
	while(s != nil && t == s.r) {
	    t = s; s = t.p;
	}
	return s ;
    }

    public static int succ(int v) {
	return treesucc(v).k;
    }

    private static treeNode treepred(int v) {
	treeNode t, s;
	t = treesearch(v);
	if(t.l != nil) 
          return nodemax(t.l);
	s = t.p;
	while(s != nil && t == s.l) {
	    t = s; s = t.p;
	}
	return s ;
    }

    public static int pred(int v) {
	return treepred(v).k;
    }

    public static void insert(int v) {
	treeNode t, prec;
	prec = nil; 
        t = root;
	while(t != nil) {
	    prec = t; 
            t = ((v < t.k) ? t.l : t.r);
	}
	t = new treeNode();
	t.k = v; t.p = prec; t.l = t.r = nil;
	if(prec == nil) 
           root = t;
	else if(v < prec.k) 
           prec.l = t; 
        else 
           prec.r = t;
    }

 // Deletes an element. 
 // If the element has two children, swap it with its successor and drop it
 // (Like in Cormen et al.)
     public static void r_delete(int v) {
	treeNode t, s, r;
	t = treesearch(v);
        if (t==nil) return;
	if (t.l == nil || t.r == nil) // v has 0 or 1 children
          s = t; 
        else // v has 2 childred
          s = treesucc(v);
        // s has at most one child
	if(s.l != nil) 
          r = s.l; 
        else 
          r = s.r;
	r.p = s.p; 
	if(s.p == nil) // s is the root
          root = r;
	else if(s == s.p.l) // s is a left child
          s.p.l = r; 
        else // s is a right child
          s.p.r = r;
	if(s != t) // v had 2 children
          t.k = s.k;
    }

 // Deletes an element. 
 // If the element has two children, swap it with its predecessor and drop it
 // (Symmetric wrt. that in Cormen et al.)
     public static void l_delete(int v) {
	treeNode t, s, r;
	t = treesearch(v);
        if (t==nil) return;
	if (t.l == nil || t.r == nil) // v has 0 or 1 children
          s = t; 
        else // v has 2 childred
          s = treepred(v);
        // s has at most one child
	if(s.l != nil) 
          r = s.l; 
        else 
          r = s.r;
	r.p = s.p; 
	if(s.p == nil) // s is the root
          root = r;
	else if(s == s.p.l) // s is a left child
          s.p.l = r; 
        else // s is a right child
          s.p.r = r;
	if(s != t) // v had 2 children
          t.k = s.k;
    }

  public static void main(String args[]) {
      Scanner in = new Scanner(System.in);  
      int key = 0;
      char option = 'a';
      String opt = null;
      treeNode  pos;
      init();
      do {
	    System.out.println("Options:");
	    System.out.println(" i: insert new element");
	    System.out.println(" r: delete the element with given key (right)");
	    System.out.println(" l: delete the element with given key (left)");
	    System.out.println(" s: search for an element");
	    System.out.println(" m: search for the minimum");
	    System.out.println(" M: search for the maximum");
	    System.out.println(" n: search for the successor");
	    System.out.println(" e: search for the predecessor");
	    System.out.println(" p: print ordered");
	    System.out.println(" d: print indented");
          opt = in.next(); option = opt.charAt(0);
          switch (option) {
	    case 'i': 
              key = readInfo();
              insert(key);
		break;
	    case 'r': 
              key = readInfo();
              r_delete(key);
	      break;
	    case 'l': 
              key = readInfo();
              l_delete(key);
	      break;
	    case 's': 
              key = readInfo();
              pos= treesearch(key);
              if (pos==nil)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'n': 
              key = readInfo();
              pos= treesucc(key);
              if (pos==nil)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'e': 
              key = readInfo();
              pos= treepred(key);
              if (pos==nil)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'm': 
              pos= treemin();
              if (pos==nil)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'M': 
              pos= treemax();
              if (pos==nil)
                 System.out.printf("Not found\n");
              else
		  System.out.printf("Found, key = %d\n",pos.k);
	      break;
	    case 'p': 
              print();
	      break;
	    case 'd': 
              printIndent();
	      break;
            default:
	    break;
	    }
	} while (
         option == 'e' || 
         option == 'i' || 
         option == 'r' || 
         option == 'l' || 
         option == 's' || 
         option == 'm' || 
         option == 'M' || 
         option == 'n' || 
         option == 'd' || 
         option == 'p' 
        );
  }

}
